package com.cedarsoft.utils.tags.ui;

import com.cedarsoft.utils.tags.Tag;
import com.cedarsoft.utils.tags.TagProvider;
import com.cedarsoft.utils.tags.Taggable;
import org.jetbrains.annotations.NotNull;

/**
 * Dummy implementation
 */
public class DefaultTagsComponentModel implements TagsComponentModel {
  @NotNull
  private final TagProvider tagProvider;
  @NotNull
  private final Taggable selectedTags;

  public DefaultTagsComponentModel( @NotNull TagProvider tagProvider, @NotNull Taggable selectedTags ) {
    this.selectedTags = selectedTags;
    this.tagProvider = tagProvider;
  }

  public void selectTag( @NotNull Tag tag ) {
    selectedTags.addTag( tag );
  }

  @NotNull
  public TagProvider getTagProvider() {
    return tagProvider;
  }

  @NotNull
  public Taggable getSelectedTags() {
    return selectedTags;
  }

  public void unselectTag( @NotNull Tag tag ) {
    if ( !selectedTags.removeTag( tag ) ) {
      throw new IllegalStateException( "Could not remove tag: " + tag );
    }
  }
}
